import { useState } from 'react';
import historykana from 'historykana';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var createInitialHash = function (fieldNames, defaultValue) {
    return fieldNames.reduce(function (acc, fieldName) {
        acc[fieldName] = defaultValue;
        return acc;
    }, {});
};
var useKana = function (fieldNames) {
    var _a = useState(createInitialHash(fieldNames, [])), history = _a[0], setHistory = _a[1];
    var _b = useState(createInitialHash(fieldNames, '')), kana = _b[0], setKana = _b[1];
    var setKanaSource = function (_a) {
        var _b, _c;
        var fieldName = _a.fieldName, inputtedValue = _a.inputtedValue;
        var newHistory = inputtedValue
            ? __spreadArrays(history[fieldName], [inputtedValue]) : [];
        setHistory(__assign(__assign({}, history), (_b = {}, _b[fieldName] = newHistory, _b)));
        setKana(__assign(__assign({}, kana), (_c = {}, _c[fieldName] = historykana(newHistory), _c)));
    };
    return { kana: kana, setKanaSource: setKanaSource };
};

export { useKana };
